;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;
; "Mad Jack" key patch
;
;================================
;ORG 410A
;	CALL KeyPatch   POKE 16650,205
;			POKE 16651,152
;			POKE 16652,66
;	CP "Q"		POKE 16654,Up
;	JR Z, Lb4125 	
;	CP "P"		POKE 16658,Right
;	JR Z, Lb414A
;	NOP		POKE 16661,00
;	NOP		POKE 16662,00
;	NOP		POKE 16663,00
;	CP "O" 		POKE 16665,Left
;	JP Z 4163
;	CP "A" 		POKE 16670,Down
;	JP Z 4145
;	JP 4174
;================================

ORG 4298

@Keyboard=02BB			;Keyboard scanning subroutine
@Decode=07BD			;Keyboard decode subroutine

@KeyPatch
	PUSH BC
	PUSH DE
	PUSH HL
	CALL Keyboard		;Call keyboard scanning routine
	LD B,H 			;BC=Raw Key values
	LD C,L
	LD D,C			;Test for keypress , D=FF if no key
	LD A,C			;A=FF
	INC D 			;D=0 if no key 
	JR Z NoKey		;No keypress
	CALL Decode		;Decode routine converts BC to ZX81 keycodes
	LD A,(HL)		;A=CHR CODE
@NoKey
	POP HL
	POP DE
	POP BC
	RET
